<template>
    <Header />

    <main class="w-[1390px] m-0 m-auto">
        <div class="mt-5 mb-12">
            <p class="font-light cursor-pointer">
                <RouterLink to="/">Главная</RouterLink> > <RouterLink :to="{ name: 'basket' }">Корзина</RouterLink>
            </p>
        </div>

        <div class="mb-5">
            <p class="text-2xl">Корзина</p>
        </div>

        <div class="grid grid-cols-2 divide-x  mb-16">
            <div>
                <p class="text-[#28303F] font-light mb-10">После оформления заказа, наш менеджер свяжеться с вами, для
                    согласования стоимости доставки. Сейчас вы ни
                    за что не платите.</p>

                <div v-if="cart.length > 0" class="flex flex-col gap-14 mb-16 items-center">
                    <div v-for="(item, index) in cart" :key="index" class="w-[80%] grid grid-cols-[40%_1fr] items-center">
                        <div>
                            <img class="w-[9.375rem]" :src="`https://client.st.com.tm/uploads/paintings/resize/` + item.img" alt="">
                        </div>
                        <div class="h-full flex flex-col justify-between">
                            <p class="font-semibold">{{ item.title }}</p>

                            <div class="flex justify-between">
                                <p><span class="font-semibold">Размер:</span> {{ item.size }}</p>
                                <div class="flex gap-4">

                                    <button :disabled="item.quantity <= 1" class="text-gray-500 border rounded-full"
                                        :class="{ 'cursor-not-allowed': item.quantity <= 1 }">
                                        <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" viewBox="0 0 20 20"
                                            fill="currentColor">
                                            <path fill-rule="evenodd" d="M5 10a1 1 0 011-1h8a1 1 0 110 2H6a1 1 0 01-1-1z"
                                                clip-rule="evenodd" />
                                        </svg>
                                    </button>

                                    <p class="font-semibold">{{ item.quantity }}</p>

                                    <button class="text-gray-500 border rounded-full">
                                        <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" viewBox="0 0 20 20"
                                            fill="currentColor">
                                            <path fill-rule="evenodd"
                                                d="M10 4a1 1 0 011 1v4h4a1 1 0 110 2h-4v4a1 1 0 11-2 0v-4H6a1 1 0 110-2h4V5a1 1 0 011-1z"
                                                clip-rule="evenodd" />
                                        </svg>
                                    </button>
                                </div>

                                <!-- HERE SHOULD BE FUNCTION FOR DELETION ITEM FROM BASKET -->
                                <button @click="deleteItem(index)">
                                    <img src="../assets/icon/delete.svg" alt="">
                                </button>
                            </div>

                            <p class="font-semibold text-sm py-2 px-6 bg-[#7D92AA] text-white w-28">{{ item.cost }}
                                ман.</p>
                        </div>
                    </div>
                </div>



            </div>

            <div class="pl-20">
                <p class="mb-5 font-bold text-[#28303F]">Оформления заказа</p>


                <div class="flex flex-col gap-6 divide-y">
                    <div>
                        <p class="mb-4 text-[#28303F] font-light">Вид доставки</p>

                        <div class="flex gap-10">
                            <div class="flex gap-4">
                                <label class="font-bold" for="pickup">Самовызов</label>
                                <input type="radio" value="pickup" id="pickup" v-model="deliveryType" class="text-2xl">
                            </div>

                            <div class="flex gap-4">
                                <label class="font-bold" for="delivery">Доставка</label>
                                <input type="radio" value="delivery" id="delivery" v-model="deliveryType" class="text-2xl">
                            </div>
                        </div>
                    </div>

                    <div>
                        <p class="mb-4 pt-6 text-[#28303F] font-light">Способ оплаты</p>

                        <div class="flex gap-10">
                            <div class="flex gap-4">
                                <label class="font-bold" for="cash">Наличными</label>
                                <input type="radio" value="cash" id="cash" class="text-2xl" v-model="paymentMethod">
                            </div>

                            <div class="flex gap-4">
                                <label class="font-bold" for="onlinePayment">Онлайн оплата</label>
                                <input type="radio" value="onlinePayment" id="onlinePayment" class="text-2xl"
                                    v-model="paymentMethod">
                            </div>
                        </div>
                    </div>



                    <div v-if="deliveryType === 'delivery'" class="pt-6">
                        <p class="mb-4 text-[#28303F] font-light">Адрес доставки</p>

                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Город</p>
                            <input type="text" class="w-[25.375rem] border py-2 px-3" v-model="city" required>
                        </div>

                        <div>
                            <p class="text-[#959595] font-light">Адрес</p>
                            <input type="text" class="w-[25.375rem] border py-2 px-3" v-model="address" required>
                        </div>
                    </div>

                    <div class="pt-6">
                        <p class="mb-4 text-[#28303F] font-light">Ваши контакты</p>

                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Фамилия, имя</p>
                            <input type="text" class="w-[25.375rem] border py-2 px-3" v-model="fullName" required>
                        </div>

                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Номер телефона</p>
                            <div class="flex gap-3">
                                <input type="tel" class="w-[25.375rem] border py-2 px-3" v-model="phone" required>
                                <img class="cursor-pointer" src="../assets/icon/question.svg" alt="">
                            </div>
                        </div>

                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Вы в Instagram</p>
                            <div class="flex gap-3">
                                <input type="text" class="w-[25.375rem] border py-2 px-3" v-model="insta">
                                <img class="cursor-pointer" src="../assets/icon/question.svg" alt="">
                            </div>
                        </div>

                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Email (вышлем подтверждение заказа)</p>
                            <input type="email" class="w-[25.375rem] border py-2 px-3" v-model="email" required>
                        </div>

                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Комментарий</p>
                            <textarea type="email" class="w-[25.375rem] h-28 border py-2 px-3 text-start resize-none"
                                v-model="comments"></textarea>
                        </div>


                        <div class="mb-4">
                            <p class="text-[#959595] font-light">Номер подарочного сертификата</p>
                            <div class="flex gap-3">
                                <input type="number" class="w-[25.375rem] border py-2 px-3" v-model="certificate">
                                <img class="cursor-pointer" src="../assets/icon/question.svg" alt="">
                            </div>
                        </div>


                        <!-- HERE SHOULD BE TOTAL PRICE OF BASKET -->
                        <p class="mb-4">Итого: <span class="font-bold">{{ totalCost }} ман.</span></p>

                        <!-- <button class="px-12 py-3 bg-[#7D92AA] text-white" @click="postData">Оформить заказ</button> -->
                        <button @click="postData" class="px-12 py-3 bg-[#7D92AA] text-white">Оформить заказ</button>

                    </div>


                </div>
            </div>
        </div>

        <div>
            <img src="../assets/add.svg" class="mb-16" alt="">
        </div>
    </main>

    <Footer />
</template>

<script>
import Header from './Header.vue';
import Footer from "./Footer.vue"
import axios from 'axios';

export default {
    components: {
        Header, Footer
    },
    data() {
        return {
            cart: [],
            deliveryType: 'delivery',
            paymentMethod: 'onlinePayment',
            city: '',
            address: '',
            fullName: '',
            phone: null,
            insta: '',
            email: '',
            comments: '',
            certificate: null
        }
    },
    computed: {
        totalCost() {
            return this.cart.reduce((total, item) => total + item.cost, 0);
        }
    },
    mounted() {
        this.fetchBasket();
    },
    methods: {
        fetchBasket() {
            const basketData = localStorage.getItem('basket');
            if (basketData) {
                this.cart = JSON.parse(basketData);
            } else {
                this.cart = [];
            }
        },
        deleteItem(index) {
            this.cart.splice(index, 1);
            localStorage.setItem('basket', JSON.stringify(this.cart));
        },

        async postData() {
            try {
                const body = {
                    CART: this.cart,
                    address: this.address,
                    comments: this.comments,
                    deliveryType: this.deliveryType,
                    email: this.email,
                    insta: this.insta,
                    name: this.fullName,
                    paymentMethod: this.paymentMethod,
                    phone: this.phone,
                    totalCost: this.totalCost,
                    city: this.city
                };
                const response = await axios.post('https://client.st.com.tm/api/orders', body)
                console.log(response);


                if (response.status === 200) {
                    // Clear the basket
                    this.cart = [];
                    localStorage.setItem('basket', JSON.stringify(this.cart));

                    // Reset input fields
                    this.address = '';
                    this.comments = '';
                    this.deliveryType = 'delivery';
                    this.email = '';
                    this.insta = '';
                    this.fullName = '';
                    this.paymentMethod = 'onlinePayment';
                    this.phone = null;
                    this.city = '';
                }
            } catch (error) {
                console.log(error)
            }
        }
    }
}
</script>

<style scoped></style>